<?php

namespace AMZcockpitDoctrine\Repository;

use Doctrine\ORM\QueryBuilder;
use Symfony\Component\Intl\Intl;
use AMZcockpitDoctrine\Entity\User;

/**
 * UserConnectionRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class UserConnectionRepository extends \Doctrine\ORM\EntityRepository
{
    /**
     * @return array
     */
    public function cleanLogs()
    {
        $date = new \DateTime();
        $date->sub(new \DateInterval('P6M'));
        $qb = $this->createQueryBuilder('co');
        $qb->delete();
        $qb->andWhere($qb->expr()->lte('co.logoutDate',':logoutDate'))
        ->setParameter('logoutDate',$date);
        return $qb->getQuery()->execute();
    }

    public function getLogsByFilters(User $user, array $filters) {

        /** @var QueryBuilder $qb */
        $qb = $this->createQueryBuilder('l');
        $qb->select('l')->addSelect('u.email')
            ->leftJoin('l.user','u');

        $groups = $user->getGroups();
        if($user->getGroup()->hasGroupRole()) {
            foreach ($user->getGroup()->getChildsGroups() as $child) {
                $groups->add($child);
            }
        }

        if( isset($filters['group']) && !$groups->contains($filters['group']))
            unset($filters['group']);

        if( isset($filters['group']))
            $groups = [$filters['group']];

        $qb->where($qb->expr()->isMemberOf(':groups','u.groups'))
            ->setParameter('groups', $groups);

        if($filters) {
            if(!empty($filters['from']) && !empty($filters['to'])) {
                if(!empty($filters['from'])) {
                    $from = $filters['from'];
                    $from   = new \DateTime($from->format("Y-m-d")." 00:00:00");
                    if(!empty($filters['to'])) {
                        $to   = $filters['to'];
                        $to   = new \DateTime($to->format("Y-m-d")." 23:59:59");
                        /** @var QueryBuilder $qb */
                        $qb
                            ->andWhere(
                                $qb->expr()->orX(
                                    'l.loginDate BETWEEN :from AND :to',
                                    'l.logoutDate BETWEEN :from AND :to'
                                )
                            )
                            ->setParameter('from', $from )
                            ->setParameter('to', $to);
                    } else {

                        /** @var QueryBuilder $qb */
                        $qb
                            ->andWhere('l.loginDate >= :from')
                            ->setParameter('from', $from );
                    }
                }
            }

            if(!empty($filters['users']) && !empty($filters['users'])) {
                /** @var QueryBuilder $qb */
                $qb
                    ->andWhere($qb->expr()->eq('l.user',':user'))
                    ->setParameter('user', $filters['users'] );
            }
        }

        return $qb->getQuery()->getResult();
    }

    public function getCurrentConnectedUsers() {

    }

    /**
     * @return array
     */
    public function getConnexionsAverageTime() {

        /** @var QueryBuilder $qb */
        $qb = $this->createQueryBuilder('l');
        $qb->select('AVG(time_diff(l.logoutDate, l.loginDate)) as _avg');
        $seconds = $qb->getQuery()->getSingleScalarResult();

        $dtF = new \DateTime('@0');
        $dtT = new \DateTime("@$seconds");
        return $dtF->diff($dtT)->format('%hH %im %ss');
    }

    /**
     * @return array
     */
    public function getConnexionsCountGraph() {

        /** @var QueryBuilder $qb */
        $qb = $this->createQueryBuilder('l');
        $qb->select('l.loginDate,DAY(l.loginDate) AS gDay, MONTH(l.loginDate) AS gDmonth, YEAR(l.loginDate) AS gDyear,AVG(time_diff(l.logoutDate, l.loginDate)) as _avg, COUNT(l.id) as _count');
        $qb->addGroupBy('gDay');
        $qb->addGroupBy('gDmonth');
        $qb->addGroupBy('gDyear');
        $qb->orderBy('gDyear','ASC');
        $qb->addOrderBy('gDmonth','ASC');
        $qb->addOrderBy('gDay','ASC');

        $items = $qb->getQuery()->getResult();

        $return = [];
        foreach ($items as $item) {
            $return[] = [
                'date' => $item['loginDate']->format('Y-m-d'),
                'value' => (int)$item['_count']
            ];
        }

        return $return;
    }

    /**
     * @return array
     */
    public function getConnexionCountryRepartition() {

        /** @var QueryBuilder $qb */
        $qb = $this->createQueryBuilder('l');
        $qb->select('COUNT(l) as gCount , l.countryCode as countryCode');
        $qb->groupBy('countryCode');

        $items = $qb->getQuery()->getResult();

        $unknownCountry = 0;
        $return = [];
        foreach ($items as $item) {
            if(is_null($item['countryCode'])) {
                $unknownCountry = $item['gCount'];
            } else {
                $return[] = [
                    'name'      => Intl::getRegionBundle()->getCountryName($item['countryCode']),
                    'code'      => $item['countryCode'],
                    'value'     => $item['gCount']
                ];
            }
        }

        return [
            'data' => $return,
            'unknownCountryConnexionCount' => $unknownCountry
        ];
    }

}
